require '_h2ph_pre.ph';

unless(defined(&_ALPHA_INTR_H_)) {
    eval 'sub _ALPHA_INTR_H_ () {1;}' unless defined(&_ALPHA_INTR_H_);
    require 'sys/queue.ph';
    require 'machine/atomic.ph';
    eval 'sub IPL_NONE () {0;}' unless defined(&IPL_NONE);
    eval 'sub IPL_BIO () {1;}' unless defined(&IPL_BIO);
    eval 'sub IPL_NET () {2;}' unless defined(&IPL_NET);
    eval 'sub IPL_TTY () {3;}' unless defined(&IPL_TTY);
    eval 'sub IPL_CLOCK () {4;}' unless defined(&IPL_CLOCK);
    eval 'sub IPL_HIGH () {5;}' unless defined(&IPL_HIGH);
    eval 'sub IPL_SERIAL () {6;}' unless defined(&IPL_SERIAL);
    eval 'sub IST_UNUSABLE () {-1;}' unless defined(&IST_UNUSABLE);
    eval 'sub IST_NONE () {0;}' unless defined(&IST_NONE);
    eval 'sub IST_PULSE () {1;}' unless defined(&IST_PULSE);
    eval 'sub IST_EDGE () {2;}' unless defined(&IST_EDGE);
    eval 'sub IST_LEVEL () {3;}' unless defined(&IST_LEVEL);
    if(defined(&_KERNEL)) {
	eval 'sub splx {
	    local($s) = @_;
    	    eval q((($s) ==  &ALPHA_PSL_IPL_0 ?  &spl0() :  &alpha_pal_swpipl($s)));
	}' unless defined(&splx);
	eval 'sub spllowersoftclock () {
	    eval q( &alpha_pal_swpipl( &ALPHA_PSL_IPL_SOFT));
	}' unless defined(&spllowersoftclock);
	eval 'sub splsoft () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_SOFT));
	}' unless defined(&splsoft);
	eval 'sub splsoftserial () {
	    eval q( &splsoft());
	}' unless defined(&splsoftserial);
	eval 'sub splsoftclock () {
	    eval q( &splsoft());
	}' unless defined(&splsoftclock);
	eval 'sub splsoftnet () {
	    eval q( &splsoft());
	}' unless defined(&splsoftnet);
	eval 'sub splnet () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_IO));
	}' unless defined(&splnet);
	eval 'sub splbio () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_IO));
	}' unless defined(&splbio);
	eval 'sub splimp () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_IO));
	}' unless defined(&splimp);
	eval 'sub spltty () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_IO));
	}' unless defined(&spltty);
	eval 'sub splserial () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_IO));
	}' unless defined(&splserial);
	eval 'sub splclock () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_CLOCK));
	}' unless defined(&splclock);
	eval 'sub splstatclock () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_CLOCK));
	}' unless defined(&splstatclock);
	eval 'sub splhigh () {
	    eval q( &_splraise( &ALPHA_PSL_IPL_HIGH));
	}' unless defined(&splhigh);
	eval 'sub spllpt () {
	    eval q( &spltty());
	}' unless defined(&spllpt);
	eval 'sub SIR_NET () {0x1;}' unless defined(&SIR_NET);
	eval 'sub SIR_CLOCK () {0x2;}' unless defined(&SIR_CLOCK);
	eval 'sub SIR_SERIAL () {0x4;}' unless defined(&SIR_SERIAL);
	eval 'sub setsoft {
	    local($x) = @_;
    	    eval q( &atomic_setbits_ulong( &ssir, ($x)));
	}' unless defined(&setsoft);
	eval 'sub setsoftnet () {
	    eval q( &setsoft( &SIR_NET));
	}' unless defined(&setsoftnet);
	eval 'sub setsoftclock () {
	    eval q( &setsoft( &SIR_CLOCK));
	}' unless defined(&setsoftclock);
	eval 'sub setsoftserial () {
	    eval q( &setsoft( &SIR_SERIAL));
	}' unless defined(&setsoftserial);
	eval 'sub ALPHA_IPI_HALT () {0x0000000000000001;}' unless defined(&ALPHA_IPI_HALT);
	eval 'sub ALPHA_IPI_TBIA () {0x0000000000000002;}' unless defined(&ALPHA_IPI_TBIA);
	eval 'sub ALPHA_IPI_TBIAP () {0x0000000000000004;}' unless defined(&ALPHA_IPI_TBIAP);
	eval 'sub ALPHA_IPI_SHOOTDOWN () {0x0000000000000008;}' unless defined(&ALPHA_IPI_SHOOTDOWN);
	eval 'sub ALPHA_IPI_IMB () {0x0000000000000010;}' unless defined(&ALPHA_IPI_IMB);
	eval 'sub ALPHA_IPI_AST () {0x0000000000000020;}' unless defined(&ALPHA_IPI_AST);
	eval 'sub ALPHA_NIPIS () {6;}' unless defined(&ALPHA_NIPIS);
	eval 'sub ALPHA_SHARED_INTR_DISABLE {
	    local($asi, $num) = @_;
    	    eval q((($asi)[$num]. &intr_maxstrays != 0 && ($asi)[$num]. &intr_nstrays == ($asi)[$num]. &intr_maxstrays));
	}' unless defined(&ALPHA_SHARED_INTR_DISABLE);
    }
}
1;
